/*
    Based on Neil Kolban example for IDF: https://github.com/nkolban/esp32-snippets/blob/master/cpp_utils/tests/BLE%20Tests/SampleNotify.cpp
    Ported to Arduino ESP32 by Evandro Copercini
    Adapted for MIT AI2 by Ugo Schiara  27/01/2023
*/
#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>
#include <stdlib.h>

BLEServer *pServer = NULL;
BLECharacteristic * pTxCharacteristic;
bool deviceConnected = false;
bool oldDeviceConnected = false;
bool CharReceived = false;

String txValue = "";
String RxValue = "";

unsigned int KeyPressed;

#define SERVICE_UUID           "6E400001-B5A3-F393-E0A9-E50E24DCCA9E" // Server service UUID
#define CHARACTERISTIC_UUID_RX "6E400002-B5A3-F393-E0A9-E50E24DCCA9E"
#define CHARACTERISTIC_UUID_TX "6E400003-B5A3-F393-E0A9-E50E24DCCA9E"


//==========================================================================================================
class MyServerCallbacks: public BLEServerCallbacks 
{
    void onConnect(BLEServer* pServer) 
    {
      deviceConnected = true;
                    Serial.println("Connected");
    };

    void onDisconnect(BLEServer* pServer) 
    {
      deviceConnected = false;
                     Serial.println("Disconnected");
    }
};


//==========================================================================================================
class MyCallbacks: public BLECharacteristicCallbacks 
{
    void onWrite(BLECharacteristic *pCharacteristic) 
    {
      std::string rxValue = pCharacteristic->getValue();
      for (int i=0; i < length(rxValue) ; i++) RxValue = RxValue + rxValue[i];
       CharReceived = true;
    }
};


//==========================================================================================================
void setup() {
  Serial.begin(115200);

  // Create the BLE Device
  BLEDevice::init("Server Service");

  // Create the BLE Server
  pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());

  // Create the BLE Service
  BLEService *pService = pServer->createService(SERVICE_UUID);

  // Create a BLE Characteristic
  pTxCharacteristic = pService->createCharacteristic(CHARACTERISTIC_UUID_TX,BLECharacteristic::PROPERTY_READ);
                      
  pTxCharacteristic->addDescriptor(new BLE2902());

  BLECharacteristic * pRxCharacteristic = pService->createCharacteristic(CHARACTERISTIC_UUID_RX,BLECharacteristic::PROPERTY_WRITE);

  pRxCharacteristic->setCallbacks(new MyCallbacks());

  // Start the service
  pService->start();

  // Start advertising
  pServer->getAdvertising()->addServiceUUID(pService->getUUID());
  pServer->getAdvertising()->start();
  Serial.println("Waiting a client connection to notify...");
}

//==========================================================================================================
void loop() 

{
    if (deviceConnected) {
       // pTxCharacteristic->setValue(&txValue);
       // pTxCharacteristic->notify();
       // txValue++;
    delay(10); // bluetooth stack will go into congestion, if too many packets are sent
  }

    // disconnecting
    if (!deviceConnected && oldDeviceConnected) {
        delay(500); // give the bluetooth stack the chance to get things ready
        pServer->startAdvertising(); // restart advertising
        Serial.println("start advertising");
        oldDeviceConnected = deviceConnected;
    }
    // connecting
    if (deviceConnected && !oldDeviceConnected) {
    // do stuff here on connecting
        oldDeviceConnected = deviceConnected;
    }


if(CharReceived)
{
        CharReceived = false;
        Serial.println(rxValue);      
       /* switch (rxValue)
        {
                case 1 : Serial.println("Pressed 1; Switch ON LED 1");  txValue = rxValue;
        break;
                case 2 : Serial.println("Pressed 2; Switch ON LED 2");  txValue = rxValue;
        break;   
                case 3 : Serial.println("Pressed 3; Switch ON LED 3");
        break;  
                case 10 : Serial.println("Pressed 10; Switch OFF LED 5");  txValue = rxValue;
        break;  
        default:   
        }*/
 }        


}

